// Copyright Andrew Williams and the University of Bolton
// Do what you like with the program, but please include your
// sourcecode with any distribution and retain my copyright notices

/* Version 3.0 */


// An AWBullet is exactly like an AWSprite except that it keeps track of
//  whether it is "inUse". If it is, it means this bullet (or missile
//  or bomb or arrow or whatever) has been fired and it is still going
//  ie it hasn't yet disappeared from the screen area.

#include "AWSprite.h"
#include "AWBullet.h"


AWBullet::AWBullet(char *bmpName, Uint32 hmf) : AWSprite(bmpName, hmf) {
    inUse = false;
}

// This allows the creation of an AWBullet which is merely a blank surface
//  In other words, no image file is involved.
AWBullet::AWBullet(Uint32 w, Uint32 h) : AWSprite(w, h) {
    inUse = false;
}

void AWBullet::update_everything(Uint32 topLeftX, Uint32 topLeftY) {
    if(!inUse) return;
    if(is_on_screen(topLeftX, topLeftY)) {
        updateEverythingTicks = SDL_GetTicks();
        auto_move();
        auto_animate();
        auto_accelerate();
        map_world_to_screen(topLeftX, topLeftY);
        draw();
    } else {
        inUse = false;
        set_auto_move(0);
        set_auto_animate(0);
        set_auto_accelerate(0);
    }
}

void AWBullet::update_everything() {
    update_everything(0, 0);
}

