#ifndef     HERD_DOT_H
#define     HERD_DOT_H          (1)

#include "SoundManager.h"
#include "Sheep.h"
#include <vector>
#include "AWMagazine.h"
#include "AWBullet.h"

using namespace std;

class Herd {
private:
    vector <Sheep *> herdOfSheep;
    Sheep *runningSheep;
    int howManySheep;
    SoundManager *soundManager;
    AWMagazine *sheepZZZs[HOWMANYRUNNERS];
public:
    Herd(int howMany, SoundManager *sM);
    ~Herd();
    void send_a_runner();
    void update();
    Sheep *get_running_sheep();
    void runner_was_hit();
    void runner_got_away();
    int choose_an_eater();
    void reset();
};


Herd::Herd(int howMany, SoundManager *sM) {
    int s;
    Sheep *sheep;

    int m;
    for(m=0; m < HOWMANYRUNNERS; m++) {
        sheepZZZs[m] = new AWMagazine(6, "zzz.bmp", 15);
        sheepZZZs[m]->set_transparent_colour(255, 255, 255);
        sheepZZZs[m]->set_auto_fire(500);
    }
    howManySheep = howMany;
    soundManager = sM;
    for(s=0; s < howMany; s++) {
        sheep = new Sheep(s * (200/howMany), sM);
        herdOfSheep.push_back(sheep);
    }
    runningSheep = NULL;
}

Herd::~Herd() {
}

void Herd::reset() {
    int s;
    for(s=0; s < howManySheep; s++) {
        herdOfSheep[s]->reset(s * (200/howManySheep));
    }
    runningSheep = NULL;

    // Reset the ZZZs magazines
    int m;
    int z;
    AWBullet *zBullet;
    for(m=0; m < HOWMANYRUNNERS; m++) {
        for(z=0; z < sheepZZZs[m]->size(); z++) {
            zBullet = sheepZZZs[m]->get(z);
            zBullet->inUse = false;
            zBullet->set_auto_animate(0);
            zBullet->set_auto_move(0);
        }
    }
}


int Herd::choose_an_eater() {
    int r;
    do {
        r = rand() % howManySheep;
    } while(herdOfSheep[r]->get_state() != EATING);

    return r;
}


void Herd::send_a_runner() {
    if(runningSheep != NULL) return;        // should never happen
    int s;

    s = choose_an_eater();
    runningSheep = herdOfSheep[s];
    runningSheep->make_a_run_for_it();
}

void Herd::update() {
    int s=0;
    AWBullet *bulletZ;
    int sleeper = 0;

    for(s=0; s < herdOfSheep.size(); s++) {
        herdOfSheep[s]->update();
        if(herdOfSheep[s]->get_state() == SLEEPING) {
            bulletZ = sheepZZZs[sleeper]->allocate_a_bullet();
            if(bulletZ != NULL) {
                bulletZ->set_surface_alpha(190);
                bulletZ->set_auto_animate(180);
                bulletZ->set_world_position(herdOfSheep[s]->get_x()+54, herdOfSheep[s]->get_y() + 30);
                bulletZ->set_velocities(0.0f, -5.2f);
                bulletZ->set_auto_move(160);
            }
            sheepZZZs[sleeper]->update_everything();
            sleeper++;
        }
    }
    if(runningSheep != NULL) {
        if(runningSheep->get_state() == GOTAWAY) {
            runningSheep = NULL;
        }
    }
}

Sheep *Herd::get_running_sheep() {
    return runningSheep;
}

void Herd::runner_was_hit() {
    if(runningSheep == NULL) return;    // should never happen

    runningSheep->go_to_sleep();
    runningSheep = NULL;
}

// This is a bit clumsy really; we should probably clear runningSheep at the point when
//  we set state to GOTAWAY - we do it this way so Game can query state rather than
//  checking if runningSheep is NULL. Not sure what's best really, probably not this...
void Herd::runner_got_away() {
    runningSheep = NULL;
}

#endif



