// Copyright Andrew Williams and the University of Bolton
// Do what you like with the program, but please include your
// sourcecode with any distribution and retain my copyright notices

#include "AWSplashScreen.cpp"
#include "ScoreScreen.h"

ScoreScreen::ScoreScreen(char *bmpName, unsigned int times[HOWMANYRUNNERS]) : AWSplashScreen(bmpName) {
	font = new AWFont("vera.bmp", "vera.dat");
	int r;
	unsigned int totalTime = 0;
	for(r=0; r < HOWMANYRUNNERS; r++) {
        savedTimes[r] = times[r];
        totalTime += times[r];
	}
	averageTime = totalTime / 5;
}



void ScoreScreen::eventloop_before_flip(SDL_Surface *screen) {
    int r, y;
    int end;
    for(r=0 ; r < HOWMANYRUNNERS; r++) {
        y = 50 + (r*18);
        end = font->print_integer(r+1, 90, y);
        end = font->print_string(". ", end, y);
        end = font->print_integer(savedTimes[r], end, y);
        font->print_string(" milliseconds", end, y);
    }
    end = font->print_string("AVERAGE: ", 42, y+22);
    end = font->print_integer(averageTime, end, y+22);
    font->print_string(" milliseconds", end, y+22);
}

